import sys
from feat2acc_fold import COMPS

USAGE = '''bothwrong.py FILE0 FILE1 FILE2 FILE3 NAME1 NAME2 NAME3
Ex. bothwrong.py ~/subloc/data/hallett2005/pslt.pred.%s
../../hallett2005_meme/n10w4oops.all/acc_flat_c.01/Yeast.pred.%s
../../hallett2005_genhmm/n10b100i100bg530.all/acc_flat_c.01/Yeast.pred.%s
../../hallett2005_dischmm/n10b100i100b1i200bg530.single2all/acc_flat_c.01/Yeast.pred.%s
meme ghmm dhmm'''

def findAllWrong(filePatterns, methods):
    assert len(filePatterns) == len(methods)
    outFilename = '_'.join(methods) + '.allwrong'
    id2pred = {}; id2correct = {}
    for comp in comps:
        inFps = [open(pattern % comp) for pattern in filePatterns]
        for line0 in inFps[0]:
            (id0, pred0) = line0.split('\t')[:2]; pred0 = pred0[:-1]#remove \n
            preds = [pred0]
            if pred0 == comp: id2correct[id0] = 1
            for fp in inFps[1:]:
                line = fp.readline()
                (id, pred) = line.split('\t')[:2]; pred = pred[:-1] #remove \n
                assert id == id0
                preds.append(pred)
                if pred == comp: id2correct[id0] = 1
            if id0 not in id2pred:
                id2pred[id0] = ['Anno=' + comp,] + preds
            else:
                oldPreds = id2pred[id0]
                assert preds == oldPreds[1:]
                oldPreds[0] = oldPreds[0] + '/' + comp
        for fp in inFps: fp.close()
    outFp = open(outFilename, 'w')
    outFp.write('#SeqId\t' + '\t\t'.join(methods) + '\t\tAnnotation\n')
    nBothWrong = 0
    for id, preds in id2pred.items():
        if id in id2correct: continue
        outFp.write('\t'.join([id] + preds[1:] + preds[:1]) + '\n')
        nBothWrong = nBothWrong + 1
    outFp.close()
    print 'Inconsistencies with annotation in %s: %d / %d' \
          % (outFilename, nBothWrong, len(id2pred))

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) <= 7: print USAGE; sys.exit(1)
    comps = COMPS
    filePattern0 = sys.argv[1]
    filePattern1 = sys.argv[2]
    filePattern2 = sys.argv[3]
    filePattern3 = sys.argv[4]
    method1      = sys.argv[5]
    method2      = sys.argv[6]
    method3      = sys.argv[7]
    findAllWrong([filePattern0, filePattern1], ['pslt', method1])
    findAllWrong([filePattern0, filePattern2], ['pslt', method2])
    findAllWrong([filePattern0, filePattern3], ['pslt', method3])
    findAllWrong([filePattern0, filePattern1, filePattern2], \
                 ['pslt', method1, method2])
    findAllWrong([filePattern0, filePattern1, filePattern3], \
                 ['pslt', method1, method3])
    findAllWrong([filePattern0, filePattern2, filePattern3], \
                 ['pslt', method2, method3])
    findAllWrong([filePattern0, filePattern1, filePattern2, filePattern3], \
                 ['pslt', method1, method2, method3])
