import sys
from memecv import sum, fastaReadAll

#Usage: check_seq2cv.py [FOLDS] [SEED] [-t]

nodeList = ['YeastSecPw', 'YeastIntra', 'YeastOrga',
            'YeastER', 'YeastGolgi', 'YeastLyso', 'YeastPM', 'YeastSecreted',
            'YeastCyto', 'YeastPero', 'YeastMito', 'YeastNuclear']
dfsCompList = nodeList[3:]

def checkSeqId(comps, fold, randSeed, seqDir):
    # Read IDs and sequences
    trainFiles = ['%s%s%str%s.fa'%(seqDir,comp,randSeed,fold) for comp in comps]
    testFiles  = ['%s%s%ste%s.fa'%(seqDir,comp,randSeed,fold) for comp in comps]
    trainSeqId = []; testSeqId = []; trainNSeq = []; testNSeq = []
    for seqFilename in trainFiles:
        idSeqs = fastaReadAll(seqFilename)
        trainSeqId.append([idSeq[0].split()[0] for idSeq in idSeqs])
        trainNSeq.append(len(idSeqs))
    for seqFilename in testFiles:
        idSeqs = fastaReadAll(seqFilename)
        testSeqId.append([idSeq[0].split()[0] for idSeq in idSeqs])
        testNSeq.append(len(idSeqs))

    # Remove overlap between training and testing
    trainIds = dict([(id, 1) for ids in trainSeqId for id in ids])
    testIds = dict([(id, 1) for ids in testSeqId for id in ids])
    nUniqueOverlap = sum([(id in trainIds) for id in testIds.keys()])
    
    # Display results; overlap between training and testing should be zero
    print '%d\t%d\t%d\t%d\t%d\t%d\t%d' % (fold, sum(trainNSeq), len(trainIds),\
          sum(testNSeq), len(testIds), \
          len(trainIds)+len(testIds)-nUniqueOverlap, nUniqueOverlap)

def checkSeqIdFolds(comps, nFold, randSeed, seqDir):
    print 'Fold\tTrain\tunique\tTest\tunique\tTotal\tOverlap'
    for fold in range(nFold): checkSeqId(comps, fold, randSeed, seqDir)

#main
if __name__ == '__main__': #allows import from interpreter
    seqDir = ''; nFold = 10; randSeed = 1000
    if len(sys.argv) > 1: nFold = int(sys.argv[1])
    if len(sys.argv) > 2: randSeed = int(sys.argv[2])
    isTree = False
    if len(sys.argv) > 3: isTree = (sys.argv[3].lower() == '-t')

    if isTree: comps = nodeList
    else     : comps = dfsCompList
    checkSeqIdFolds(comps, nFold, randSeed, seqDir)
