import sys
from motif2hit import COMPS, readMotPos

def countTrue(motPosFiles, motLenFile, motNameFile):
    motNameDist = {}
    motLenList = []
    for motPosFile in motPosFiles:
        motNameInstances = readMotPos(motPosFile)
        if len(motNameInstances) == 0: continue
        motLenList1 = countMotIns(motNameInstances)
        print '%d\tin %s' % (len(motLenList1), motPosFile)
        motLenList = motLenList + motLenList1
        for motName, motIns in motNameInstances:
            motNameDist[motName] = 1
    print 'TOTAL: %d true motifs considered' % len(motLenList)

    fMotifs = open(motNameFile, 'w')
    for motName in motNameDist: fMotifs.write(motName + '\n')
    fMotifs.close()

    motLenList.sort()
    allLenStr = ' '.join([str(l) for l in motLenList])
    print allLenStr
    fp = open(motLenFile, 'w'); fp.write(allLenStr); fp.close()

def countMotIns(motNameInstances):
    motLenList = []
    for motName, motIns in motNameInstances:
        lens = [end - st for seqId, st, end in motIns]
        lens.sort()
        #print motName, lens
        motLenList.append((lens[len(lens)/2] + lens[(len(lens)+1)/2]) / 2)
    return motLenList

# main
if __name__ == '__main__': #allows import from interpreter
    motPosPattern = sys.argv[1]
    motLenFile = sys.argv[2]
    motNameFile = sys.argv[3]
    countTrue([motPosPattern % comp for comp in COMPS], motLenFile, motNameFile)
