import sys
from memecv import writeFeatures

COMPS = ['Cyto','ER','Golgi','Mito','Nuclear','Pero','PM','Lyso','Secreted']

def readArray(featFilename):
    fFeat = open(featFilename)
    featVecs = []
    for line in fFeat:
        if line == '': continue
        featVecs.append([float(token) for token in line.split()])
    fFeat.close()
    return featVecs

def combineAll(comps, seed, outDir, nFold):
    for fold in range(nFold):
        trainFeat = []; testFeat = []
        for comp in comps:
            trainFeat.append(readArray('Yeast%s%dtr%d.dat' % (comp, seed, fold)))
            testFeat.append( readArray('Yeast%s%dte%d.dat' % (comp, seed, fold)))
        trainFeatFile = '%sYeast%dtr%d.dat'   % (outDir, seed, fold)
        testFeatFile  = '%sYeast%dte%d.dat' % (outDir, seed, fold)
        writeFeatures(trainFeat, -1, trainFeatFile)
        writeFeatures(testFeat,  -1, testFeatFile)

# main
if __name__ == '__main__': #allows import from interpreter
    outDir = sys.argv[1]
    combineAll(COMPS, 1000, outDir, 10)
