#!/usr/bin/python
# Run generative motif finding on the Hallett 2004 yeast dataset in K-fold CV,
# under given parameters. The program is SUBMOTIF.
# Run all folds, scanning all compartments. By default 10-fold CV is used.
# Assumes the CV training data is ready.
# Results files are stored in current directory

import sys, os, glob

USAGE = 'genhmm_hallett.py PARAM [SEED] [NUMFOLDS]'

if len(sys.argv) <= 1: print USAGE; sys.exit(1)
param = sys.argv[1]
randSeed = '1000'
nFold = 10
if len(sys.argv) > 2: randSeed = sys.argv[2]
if len(sys.argv) > 3: nFold = int(sys.argv[3])
for fold in range(nFold):
    cmd = 'python ~/subloc/python/genhmm_hallett_fold.py %d \\"%s\\" %s' % (param, fold, randSeed)
    print cmd
    os.system('perl /export/home/install/bin/r2/qarray.pl "%s"' % cmd)
