#!/usr/bin/python
#Generate features of HMM likelihood for flat, leaf, or tree SVM classification.
#This script overlaps and replaces both hmm2feat_tree.py (supporting hmmd
#with printf-style patterns) and hmm2featflat.py (supporting tree and flat).
#To support different directory structure of hmmd, a more flexible
#command-line arguments is added.
#To support tree and flat classification, HMM compartment list (tree or leaf)
#and sequence compartment list are separated.

import sys
from feat2acc_tree import nodeList
from hmm2featflat1 import runComps, readArray, combineFold

USAGE = '''Usage: hmm2feattree1 TE_FEAT HMM TE_SEQ
Arguments:
  TE_FEAT output testing feature file pattern (ex. feattree/Yeast1000te3.dat)
  HMM     HMM file pattern (ex. hmmd/%s1000tr3.hmm)
  TE_SEQ  testing sequences
'''

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) < 4: print USAGE; sys.exit(1)
    teFeatPattern = sys.argv[1]
    hmmPattern    = sys.argv[2]
    teSeqPattern  = sys.argv[3]
    runComps(nodeList, teSeqPattern, teFeatPattern, hmmPattern)
