#List entries in the target file with ID appearing in the source file.
#The first "word" in both files are treated as ID.
#This is designed to find intersection of sequence-based assignments
#and (automatic) image-based assignments that are both inconsistent with
#the annotations.

import sys

USAGE = 'intersect SOURCE_FILE TARGET_FILE [-s]'

def intersect(sourceFile, targetFile):
    id2line = collectIds(sourceFile)
    f = open(targetFile)
    for line in f:
        id = line.split()[0]
        if id in id2line: print line[:-1], '\t', id2line[id],
    f.close()

def subtract(sourceFile, targetFile):
    id2line = collectIds(targetFile)
    f = open(sourceFile)
    for line in f:
        id = line.split()[0]
        if id not in id2line: print line,
    f.close()    

def collectIds(filename):
    f = open(filename)
    id2line = dict([(line.split()[0], line) for line in f])
    f.close()
    return id2line

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) < 3: print USAGE; sys.exit(-1)
    if len(sys.argv) > 3 and sys.argv[3] == '-s':
        subtract(sys.argv[1], sys.argv[2])
    else:
        intersect(sys.argv[1], sys.argv[2])
