#This script overlaps memecv.py (memecv.py feat ...) but supports
#the deep directory structure and more flexible file names.
#The usage is similar to hmm2featflat.py.

import sys, os
from memecv import memeFeatures, writeFeatures

USAGE = '''meme2flatfeat1 TE_FEAT MEME TE_SEQ
All parameters are printf-style patterns (e.g. motif/%s1000tr3.meme).
See script files for examples.'''

COMPS = ['YeastCyto', 'YeastER', 'YeastGolgi', 'YeastLyso', 'YeastMito',
         'YeastNuclear', 'YeastPero', 'YeastPM', 'YeastSecreted']

def runComps(comps, memePattern, teSeqPattern, teFeatFile):
    '''Generate features from motif PWM.'''
    teSeqFiles = [teSeqPattern % comp for comp in comps]
    memeFiles = [memePattern % comp for comp in comps]
    (trainFeat, testFeat) = memeFeatures(memeFiles, [], teSeqFiles)
    #featNormalize(trainFeat, testFeat)
    writeFeatures(testFeat , -1, teFeatFile)

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) < 4: print USAGE; sys.exit(1)
    teFeatFile   = sys.argv[1]
    memePattern  = sys.argv[2]
    teSeqPattern = sys.argv[3]
    runComps(COMPS, memePattern, teSeqPattern, teFeatFile)
