import re, sys, glob

if len(sys.argv) < 2: print 'memecv_result Yeast1000_'; sys.exit(1)
resultFiles = glob.glob(sys.argv[1] + '*.result')

nFold = len(resultFiles)
nComp = 9
compName = [None] * nComp; precision = [0.0] * nComp; recall = [0.0] * nComp
accuracy = 0.0
for resultFile in resultFiles:
    f = open(resultFile)
    f.readline() #svmLight2Multiclass
    for comp in range(nComp):
        line = f.readline()
        m = re.search(r'(\w+): Precision = (\d+\.?\d*), Recall = (\d+\.?\d*)', line)
        if compName[comp] == None: compName[comp] = m.group(1)
        elif compName[comp] != m.group(1): raise Exception('Wrong compartment name')
        precision[comp] = precision[comp] + float(m.group(2))
        recall[comp] = recall[comp] + float(m.group(3))
    line = f.readline()
    m = re.search(r'Accuracy of fold \d+: (\d+\.?\d*)', line)
    accuracy = accuracy + float(m.group(1))
    f.close()

for comp in range(nComp):
    print '%s: Precision = %.2f, Recall = %.2f' \
          % (compName[comp], precision[comp] / nFold, recall[comp] / nFold)
print 'Accuracy overall: %.2f' % (accuracy / nFold)
