import sys, os

USAGE = 'randhmm.py PRED2TRUE_THRESHOLD RECALL_THRESHOLD SEED_START SEED_END'
RAND2POST2HIT = '''#!/bin/bash
##if [ ! -e hmmg ] ; then mkdir hmmg/ ; fi
##if [ ! -e postflat ] ; then mkdir postflat/ ; fi
##for comp in Cyto ER Golgi Lyso Mito Nuclear Pero PM Secreted; do
##    ~/subloc/hmmer-2.3.2/subloc/subrandom -n 10 -l 4 -a 530 -s %d -g hmmg/ ~/subloc/result/hallett2005/Yeast$comp.fa
##    ~/subloc/hmmer-2.3.2/subloc/subscan -p ~/subloc/result/hallett2005/Yeast$comp.fa postflat/Yeast$comp.post hmmg/Yeast${comp}4_*.hmm
##done
python ~/subloc/python/posterior2hit.py -p %s -r %s postflat/mini.hit postflat/%%s.post ~/subloc/result/hallett2005/%%s.motpos
python ~/subloc/python/posterior2hit.py -p %s -r %s postflat/ipr.hit postflat/%%s.post ~/subloc/result/hallett2005/%%s.iprpos
python ~/subloc/python/posterior2hit.py -p %s -r %s postflat/pslt.hit postflat/%%s.post ~/subloc/result/hallett2005/%%s.psltpos
'''

if len(sys.argv) != 5: print USAGE; sys.exit()
p = sys.argv[1]
r = sys.argv[2]
seedSt = int(sys.argv[3])
seedEnd = int(sys.argv[4])
for seed in range(seedSt, seedEnd + 1):
    dir = 's%d.all' % seed
    #os.mkdir(dir)
    os.chdir(dir)
    fp = open('rand2post2hit.sh', 'w')
    fp.write(RAND2POST2HIT % (seed, p, r, p, r, p, r))
    fp.close()
    os.system('chmod +x rand2post2hit.sh') #os.chmod() is confusing to me
    os.system('./rand2post2hit.sh')
    os.chdir('..')
