#!/usr/bin/env python
# Convert the native labeled 

import sys

SEPARATOR = '//'

def convertFile(labeledFileName):
    labeledFile = open(labeledFileName)
    out = open('%s.fa' % (labeledFileName), 'w')
    allLabels = []; allLabelsCount = []
    while True: 
        name = labeledFile.readline()
        while name != '' and len(name.strip()) == 0:
            name = labeledFile.readline()
        if name == '': break
        name = name.strip()
        label = labeledFile.readline().strip()
        if label in allLabels:
            iAllLabels = allLabels.index(label)
            allLabelsCount[iAllLabels] = allLabelsCount[iAllLabels] + 1
        else: allLabels.append(label); allLabelsCount.append(1)
        out.write('>%s %s\n' % (name, label))
        seqLine = '\n'
        while seqLine != '':
            seqLine = labeledFile.readline()
            if seqLine.startswith(SEPARATOR): break
            elif len(seqLine.strip()) == 0: continue
            out.write('%s\n' % seqLine.strip())
    out.close()
    labeledFile.close()
    return (allLabels, allLabelsCount)

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) <= 1:
        print 'Usage: python seq2bigfa.py LABELED_FILE'; sys.exit(-1)
    labeledFileName = sys.argv[1]
    (allLabels, allLabelsCount) = convertFile(labeledFileName)
    print 'Label\tCount'
    for label, labelCount in zip(allLabels, allLabelsCount):
        print '%s\t%d' % (label, labelCount)
