#!/usr/bin/env python
# Convert the native labeled 

import sys

SEPARATOR = '//'

def convertFile(labeledFileName, labels):
    labeledFile = open(labeledFileName)
    out = [open('%s_%s.fa' % (labeledFileName,label), 'w') for label in labels]
    #out = open('%s_%s.fa' % (labeledFileName,label), 'w')
    allLabels = []; allLabelsCount = []
    while True: 
        name = labeledFile.readline()
        while name != '' and len(name.strip()) == 0:
            name = labeledFile.readline()
        if name == '': break
        name = name.strip()
        label = labeledFile.readline().strip()
        if label in allLabels:
            iAllLabels = allLabels.index(label)
            allLabelsCount[iAllLabels] = allLabelsCount[iAllLabels] + 1
        else: allLabels.append(label); allLabelsCount.append(1)
        if label in labels:
            iLabel = labels.index(label)
            out[iLabel].write('>%s %s\n' % (name, label))
        else: iLabel = -1
        seqLine = '\n'
        while seqLine != '':
            seqLine = labeledFile.readline()
            if seqLine.startswith(SEPARATOR): break
            elif len(seqLine.strip()) == 0: continue
            if iLabel >= 0: out[iLabel].write('%s\n' % seqLine.strip())
    for out1 in out: out1.close()
    labeledFile.close()
    return (allLabels, allLabelsCount)

# main
if __name__ == '__main__': #allows import from interpreter
    if len(sys.argv) <= 2: print 'Usage: seq2fa LABELED_FILE LABELS'; sys.exit(-1)
    labeledFileName = sys.argv[1]
    labelStr = sys.argv[2]
    labels = [ch for ch in labelStr]
    (allLabels, allLabelsCount) = convertFile(labeledFileName, labels)
##    for label, labelCount in zip(allLabels, allLabelsCount):
##        if label in labels:
##            print '%s\t%d wrote to file' % (label, labelCount)
##        else:
##            print '%s\t%d' % (label, labelCount)
