#HMM to features
./hmmd_tree_rename.sh
mkdir feattree
python ../../../python/hmm2feattree1.py feattree/%s.dat hmmd_tree/%s4_ ../../../data/hallett2005/%s.fa

#features to accuracy by SVM
mkdir acc_tree_c.01
python ../../../python/feat2acc_treetr.py feattree/Yeast.dat acc_tree_c.01/%smc.dat acc_tree_c.01/%s.svm ../../../data/hallett2005/%s.fa "-c .01"
python ../../../python/feat2acc_treete.py acc_tree_c.01/Yeast.result feattree/Yeast.dat acc_tree_c.01/%s.pred acc_tree_c.01/%s.svm ../../../data/hallett2005/%s.fa "-c .01"

#HMM to posterior decoding
mkdir posttree
for comp in Cyto ER Golgi Lyso Mito Nuclear Pero PM Secreted; do
  ../../../src/subscan -p ../../../data/hallett2005/Yeast$comp.fa posttree/Yeast$comp.post hmmd_tree/Yeast${comp}4_*.hmm
done

#posterior decoding to recover known motifs
python ../../../python/posterior2hit.py posttree/ipr.hit posttree/%s.post ../../../data/hallett2005.known/%s.iprpos
python ../../../python/posterior2hit.py posttree/mini.hit posttree/%s.post ../../../data/hallett2005.known/%s.motpos

#features to rank by SVM
mkdir rank_tree_c.01/
for feat in `seq 30 119`; do 
  ./rank_tree.sh rank_tree_c.01 "-c .01" $feat
done
grep Accuracy rank_tree_c.01/Yeast-*.result | python ../../../python/grepres2rank.py > rank_tree_c.01/Yeast.result

#posterior decoding to conservation
python ../../../python/rank2postsites.py 30 rank_tree_c.01/Yeast.post%dsites rank_tree_c.01/Yeast.result posttree/%s.post ../../../data/hallett2005/%s.fa
python ../../../python/sgda_ident.py -s rank_tree_c.01/Yeast.post30sites ../../../data/sgd_align/aln/%s.aln rank_tree_c.01/Yeast30sites.strong
echo "addpath ../../../matlab; conservation('rank_tree_c.01/Yeast30sites.strong', 'rank_tree_c.01.consres');" | matlab -nodisplay -nojvm