#HMM to features
mkdir features
python ../../../python/hmm2featflat1.py features/%s.dat hmmg/%s4_ ../../../data/hallett2005/%s.fa

#features to accuracy by SVM
mkdir acc_flat_c.01
python ../../../python/feat2acc_train.py features/Yeast.dat acc_flat_c.01/Yeast_mc.dat acc_flat_c.01/%s.svm ../../../data/hallett2005/%s.fa "-c .01"
python ../../../python/feat2acc_test.py acc_flat_c.01/Yeast.result features/Yeast.dat acc_flat_c.01/Yeast.pred acc_flat_c.01/%s.svm ../../../data/hallett2005/%s.fa "-c .01"

#HMM to posterior decoding
mkdir postflat
for comp in Cyto ER Golgi Lyso Mito Nuclear Pero PM Secreted; do
  ../../../src/subscan -p ../../../data/hallett2005/Yeast$comp.fa postflat/Yeast$comp.post hmmg/Yeast${comp}4_*.hmm
done

#posterior decoding to recover known motifs
python ../../../python/posterior2hit.py postflat/ipr.hit postflat/%s.post ../../../data/hallett2005.known/%s.iprpos
python ../../../python/posterior2hit.py postflat/mini.hit postflat/%s.post ../../../data/hallett2005.known/%s.motpos

#features to rank by SVM
mkdir rank_flat_c.01/
python ../../../python/featflat2rank.py features/Yeast.dat ../../../data/hallett2005/%s.fa rank_flat_c.01/Yeast "-c .01"

#posterior decoding to conservation
python ../../../python/rank2postsites.py 30 rank_flat_c.01/Yeast.post%dsites rank_flat_c.01/Yeast.result postflat/%s.post ../../../data/hallett2005/%s.fa
python ../../../python/sgda_ident.py -s rank_flat_c.01/Yeast.post30sites ../../../data/sgd_align/aln/%s.aln rank_flat_c.01/Yeast30sites.strong
echo "addpath ../../../matlab; conservation('rank_flat_c.01/Yeast30sites.strong', 'rank_flat_c.01.consres');" | matlab -nodisplay -nojvm