#!/bin/bash
for seed in `seq $1 $2`; do
    if [ ! -e r$seed.all ] ; then mkdir r$seed.all ; fi
    cd r$seed.all
    if [ ! -e hmmg ] ; then mkdir hmmg/ ; fi
    if [ ! -e postflat ] ; then mkdir postflat/ ; fi
    for comp in Cyto ER Golgi Lyso Mito Nuclear Pero PM Secreted; do
        ../../../src/subrandom -n 10 -l 4 -a 530 -r -s $seed -g hmmg/ ../../../data/hallett2005/Yeast$comp.fa
        ../../../src/subscan -p ../../../data/hallett2005/Yeast$comp.fa postflat/Yeast$comp.post hmmg/Yeast${comp}4_*.hmm
    done
    python ../../../python/posterior2hit.py -p 4 -r 0.33 postflat/mini.hit postflat/%s.post ../../../data/hallett2005/%s.motpos
    python ../../../python/posterior2hit.py -p 4 -r 0.33 postflat/ipr.hit  postflat/%s.post ../../../data/hallett2005/%s.iprpos
    cd ..
done
